﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Infragistics.Controls.Charts;
using System.Windows.Media.Animation;

namespace xamDataChart1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        protected ObservableDataSource DataSource = new ObservableDataSource();
        int count = 0;
        DispatcherTimer dataUpdateTimer;

        TimeSpan Interval = TimeSpan.FromSeconds(0.5);

        public MainWindow()
        {
            InitializeComponent();

            xamDataChart1.Series[0].ItemsSource = this.DataSource;
            dataUpdateTimer = new DispatcherTimer();            
            dataUpdateTimer.Interval = Interval;
            dataUpdateTimer.Tick += new EventHandler(dataUpdateTimer_Tick);
            dataUpdateTimer.Start();

            xamDataChart1.WindowScaleHorizontal = 0.01;
            xamDataChart1.WindowPositionHorizontal = 0;
        }


        void dataUpdateTimer_Tick(object sender, EventArgs e)
        {
            DoubleAnimation scaleAnimation = new DoubleAnimation(((xamDataChart1.Axes[0] as NumericXAxis).ActualMaximumValue - ((xamDataChart1.Axes[0] as NumericXAxis).ActualMaximumValue - 20)) / (xamDataChart1.Axes[0] as NumericXAxis).ActualMaximumValue, Interval);
            xamDataChart1.BeginAnimation(XamDataChart.WindowScaleHorizontalProperty, scaleAnimation);

            DoubleAnimation positionAnimation = new DoubleAnimation(xamDataChart1.WindowPositionHorizontal + 0.1, Interval);
            xamDataChart1.BeginAnimation(XamDataChart.WindowPositionHorizontalProperty, positionAnimation);

            (xamDataChart1.Axes[0] as NumericXAxis).MaximumValue = count + 1;
            DoubleAnimation axisAinmation = new DoubleAnimation((xamDataChart1.Axes[0] as NumericXAxis).ActualMaximumValue + 2, Interval);
            (xamDataChart1.Axes[0] as NumericXAxis).BeginAnimation(NumericXAxis.MaximumValueProperty, axisAinmation);
            


            this.DataSource.Add(
                new ObservableDataPoint
                {
                    X = ++count,
                    Y = (++count % 5),
                });
		}

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            dataUpdateTimer.Tick -= new EventHandler(dataUpdateTimer_Tick);
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            xamDataChart1.HorizontalZoombarVisibility = xamDataChart1.HorizontalZoombarVisibility == Visibility.Visible ? Visibility.Collapsed : Visibility.Visible;
        }


    }
}
